/*
Pencil+ Size Multiply
by kam
@kamzigi

Pencil+4のラインを一括で太くしたり補足するツール。
アニメーション対応。

ウィンドウ内で選択したライン設定のサイズを2.0倍にしたり0.5倍にできます。

ついでにキーフレームを一括削除するボタンもついてます。

*/

(
	
FX = #()
exeFX = #()
roPencilSize
	
fn fnPencilSize =
(
	--GET pencil settings
	SizeSet =#()
	for i =1 to exeFX.count do ---each Pencil renderFX
	(
		PencilFX = exeFX[i]

		num = PencilFX.linesets.count

		append SizeSet #()
		for x=1 to num do --Pencil LineSets
		(
			print "-------sets-------"
			lineSetRef = PencilFX[x] --get linesets
			subsN = PencilFX.linesets[x].numSubs
			append SizeSet[i] #()
			for y=1 to subsN do --find Pencil Lineset's ALL BRUSH SIZE
			(
				
				isBrush = true
				try(temp = lineSetRef[y].size)catch(isBrush =false) --check brush
				
				
				if (isBrush == true) do
				(
					Brush = lineSetRef[y] --set brush
					ctr = Brush.size.controller
					insflag = false
-- 					print Brush.size
					
					for ib = 1 to i do --check instanced size CTR
					(
						for xb=1 to SizeSet[ib].count do --appended lineset
						(
								for yb =1 to SizeSet[ib][xb].count do --appended brush
								(
									--Pencil+ dedault size ctr is UNDEFINED. it's impossible to set instanse by default.
									--if Ctr has bezier or something, it can be instanced.
									--so just check same controller and lineSet
									
									if(SizeSet[ib][xb][yb] != undefined)do
									(
										if(SizeSet[ib][xb][yb] == Brush)do(insflag = true)
										
										if(ctr != undefined )do
										(if(SizeSet[ib][xb][yb].size.controller == ctr)do(insflag = true))
										
									)
								)
						)
					)
					
-- 					print insflag
					if (insflag == false) then --add Brush if it's not instanced
					(
						append SizeSet[i][x] Brush
-- 						print Brush
						
						--change SIZE----------------------
						if (animButtonState) then --when animate ON
						(
							if (roPencilSize.UIrad.state == 1)then
							(Brush.size = (Brush.size * roPencilSize.UIsize.value))
							else
							(Brush.size = (Brush.size / roPencilSize.UIsize.value))
						)
						else -- when animate OFF
						(
							if (ctr == undefined) then ----default CTR
							(
								if (roPencilSize.UIrad.state == 1)then
								(Brush.size = (Brush.size * roPencilSize.UIsize.value))
								else
								(Brush.size = (Brush.size / roPencilSize.UIsize.value))
							)
							else ------for bezier CTR
							(
								if (Brush.size.isAnimated == true)then -- offset keys
								(
									if (roPencilSize.UIrad.state == 1)then
									(Brush.size.controller.keys.value *= roPencilSize.UIsize.value)
									else
									(Brush.size.controller.keys.value /= roPencilSize.UIsize.value)
								)
								else -- offset values
								(
									print"else"
									if (roPencilSize.UIrad.state == 1)then
									(Brush.size = (Brush.size * roPencilSize.UIsize.value))
									else
									(Brush.size = (Brush.size / roPencilSize.UIsize.value))
								)
								Brush.size.controller.keys.inTangentType =#auto
								Brush.size.controller.keys.outTangentType =#auto
-- 								Brush = SizeSet[i][x][y]
							)
						)
						-------------------------------------
						
					)else
					(
						append SizeSet[i][x] undefined
-- 						txt = ((Brush)as string) + " ---is instanced"
-- 						print txt
					)
					
				)
			)
		)
	)
	

)

	
fn fnDelPencilSizeKey =
(
	for i =1 to exeFX.count do ---each Pencil renderFX
	(
		PencilFX = exeFX[i]
		num = PencilFX.linesets.count

		
		for x=1 to num do --Pencil LineSets
		(
			lineSetRef = PencilFX[x]
			
			subsN = PencilFX.linesets[x].numSubs
			for y=1 to subsN do --find Pencil Lineset's ALL BRUSH SIZE
			(
				isBrush = true
				try(temp = lineSetRef[y].size)catch(isBrush =false) --check brush
-- 				print isBrush
				if (isBrush == true) do
				(
-- 					print "ARERERE"
					ctr = lineSetRef[y].size.controller
					
					if (ctr != undefined) do
					(	print ctr
						f = ctr.value
						print f
						deleteKeys ctr #allKeys
						lineSetRef[y].size = f
						deleteKeys ctr #allKeys
					)
				)
			)
		)
	)
)
	
rollout roPencilSize "Pencil_LineSize_Multiply"
(
	group ""
	(
		MultiListBox UIitem --items:
		
		spinner UIsize "Line Size [  ]" range:[0.1,100,1] type:#float
		radiobuttons UIrad labels:#("[ * ]","[ / ]")
		button UIexe "SET LineSize" width:150 height:30
		
		button UIdel "Delete ALL LineSizeKey" width:130 height:20 offset:[0,10]
	)
	
	on UIexe pressed do
	(
		undo on
		(
			exeFX = #()
			for i=1 to (UIitem.selection as array).count do
			(			
				append exeFX FX[(UIitem.selection as array)[i]]
			)
			fnPencilSize()
		)
	)
	
	on UIdel pressed do
	(
		undo on
		(
			exeFX = #()
			for i=1 to (UIitem.selection as array).count do
			(			
				append exeFX FX[(UIitem.selection as array)[i]]
			)
			fnDelPencilSizeKey()
		)
	)
	
	on roPencilSize open do
	(
		--fnGetFX
		
		UIitem.items = #()
		for i=1 to numEffects do
		(
			ef = (getEffect i)
			if ((getClassName ef) == "Pencil+ 4 Line") do
			(append FX ef)
		)
		FXname = #()
		for i=1 to FX.count do
		(FXname[i] = FX[i].name)
		UIitem.items = FXname
	)
)

PencilS = newRolloutFloater "Pencil_LineSize_Multiply" 210 340
addRollout roPencilSize  PencilS
)


